#import "QCPatch.h"
#import "QCBooleanPort.h"
#import "QCIndexPort.h"
#import "SafeStringPort.h"

@interface ShellCommandPatch : QCPatch
{
    QCBooleanPort	*inputTrigger;
	SafeStringPort	*inputCommand;
	
    SafeStringPort	*outputOutput;
	QCBooleanPort	*outputIsRunning;
	QCIndexPort		*outputReturnValue;
	BOOL			oldValue;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(id)fp8;
- (void)cleanup:(id)fp8;

- (void)enable:(id)fp8;
- (void)disable:(id)fp8;

- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20;

// threaded command execution method.  object is self
+(void)runCommand:(id)object;
@end