#include <fcntl.h>
#import "ShellCommandPatch.h"

@implementation ShellCommandPatch : QCPatch

+ (int)executionMode
{
	return 1;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	return z;
}


- (id)setup:(id)fp8
{
	oldValue = FALSE;

	return fp8;
}
- (void)cleanup:(id)fp8
{


}


- (void)enable:(id)fp8
{


}
- (void)disable:(id)fp8
{


}


- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20
{
        NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

		if( [[[self->_executionRuntime context] options] objectForKey:@"context.noNetworkConnections"] != 0 )
		{
			[pool release];
			return YES;
		}

        if([inputTrigger booleanValue] == TRUE && oldValue == FALSE)
        {
                [NSThread detachNewThreadSelector:@selector(runCommand:) toTarget:[ShellCommandPatch class] withObject:self];
                oldValue = TRUE;
        }
        else
                oldValue = [inputTrigger booleanValue];

        [pool release];
        return YES;
}

+(void)runCommand:(id)patchInstance
{
	FILE				*outputStream;
	NSAutoreleasePool	*pool = [[NSAutoreleasePool alloc] init];
	NSMutableString		*output = [[NSMutableString alloc] init];
	ShellCommandPatch	*p = (ShellCommandPatch*)patchInstance;
	char				buffer[128];
	int					i;
	
	outputStream = popen([[p->inputCommand stringValue] UTF8String],"r");
	[p->outputIsRunning setBooleanValue:TRUE];
	// we set non-block mode to allow us to catch small updates
	i = fileno(outputStream);
	fcntl(i,F_SETFL,O_NONBLOCK);

	// while the program is running, keep pumping out the output
	while(!feof(outputStream))
	{
		for(i=0;i<128;++i)
			buffer[i] = 0;
		fread(buffer,1,127,outputStream);
		[output appendFormat:@"%s",buffer];
		[p->outputOutput setStringValue:output];
		usleep(100);	// prevents us from pegging the CPU
	}
	
	// pclose returns the exit code in the high byte of its return value.  This means there are only 256 possible return codes...
	// the bottom byte is pclose's error code.
	i = pclose(outputStream) >> 8;
	//NSLog(@"retVal: %i\n",i);
	
	[p->outputReturnValue setIndexValue:(double)i];
	[p->outputIsRunning setBooleanValue:FALSE];

	[output release];
	//NSLog(@"ShellCommandPatch: runCommand thread exiting!\n");

	[pool release];
}

@end
